
/*
Copyright(C) 2007 yasu
http://hp.vector.co.jp/authors/VA013928/
http://www.usay.jp/
http://www.yasu.nu/
*/

#include "shared.h"

void crypt(int crypt)
{
	unsigned char xor1;
	unsigned short key;
	unsigned int i, j, k, n, x;

	for (i = 0; i < nLen; i+= 0x200)
	{
		key = (i >> 9) ^ 0x484A;

		for (j = 0; j < 0x200; j++)
		{
			xor1 = (key & 3) | ((key >> 4) & 0x0c) | ((key >> 5) & 0x10) | ((key >> 6) & 0x60) | ((key >> 7) & 0x80);

			if ( crypt)			// encrypt
				src[i | j] ^= xor1;

			x = n = ((src[i | j] << 8) ^ key) << 16;

			if (!crypt)			// decrypt
				src[i | j] ^= xor1;

			for (k = 1; k < 32; k++)
				x ^= n >> k;

			key  = (x >> 25) & 0x0003;
			key ^= (x >> 22) & 0x0300;
			key ^= (x >>  8) & 0x8000;
			key ^= (n >> 24) & 0x0003;
			key ^= (n >> 23) & 0x00fc;
			key ^= (n >> 22) & 0x00fc;
			key ^= (n >>  8) & 0x7f00;
		}
	}
}
